[BACK]Return to rc CVS log [TXT][DIR] Up to [local] / src / etc

Annotation of src/etc/rc, Revision 1.575

1.575   ! deraadt     1: #      $OpenBSD: rc,v 1.574 2024/04/02 08:21:04 deraadt Exp $
1.1       deraadt     2:
1.450     rpe         3: # System startup script run by init on autoboot or after single-user.
                      4: # Output and error are redirected to console by init, and the console is the
                      5: # controlling terminal.
1.454     rpe         6:
                      7: # Turn off Strict Bourne shell.
                      8: set +o sh
1.1       deraadt     9:
1.131     millert    10: # Subroutines (have to come first).
                     11:
1.456     rpe        12: # Strip in- and whole-line comments from a file.
                     13: # Strip leading and trailing whitespace if IFS is set.
                     14: # Usage: stripcom /path/to/file
1.131     millert    15: stripcom() {
1.456     rpe        16:        local _file=$1 _line
1.131     millert    17:
1.456     rpe        18:        [[ -s $_file ]] || return
                     19:
                     20:        while read _line ; do
                     21:                _line=${_line%%#*}
                     22:                [[ -n $_line ]] && print -r -- "$_line"
                     23:        done <$_file
1.131     millert    24: }
                     25:
1.456     rpe        26: # Update resource limits based on login.conf settings.
                     27: # Usage: update_limit -flag capability
1.265     millert    28: update_limit() {
1.456     rpe        29:        local _flag=$1          # ulimit flag
                     30:        local _cap=$2 _val      # login.conf capability and its value
                     31:        local _suffix
                     32:
1.490     otto       33:        for _suffix in {,-max,-cur}; do
1.456     rpe        34:                _val=$(getcap -f /etc/login.conf -s ${_cap}${_suffix} daemon 2>/dev/null)
                     35:                [[ -n $_val ]] || continue
                     36:                [[ $_val == infinity ]] && _val=unlimited
                     37:
                     38:                case $_suffix in
                     39:                -cur)   ulimit -S $_flag $_val
                     40:                        ;;
                     41:                -max)   ulimit -H $_flag $_val
                     42:                        ;;
                     43:                *)      ulimit $_flag $_val
                     44:                        return
                     45:                        ;;
                     46:                esac
1.265     millert    47:        done
                     48: }
                     49:
1.457     rpe        50: # Apply sysctl.conf(5) settings.
1.265     millert    51: sysctl_conf() {
1.520     bluhm      52:        # do not use a pipe as limits would only be applied to the subshell
                     53:        set -- $(stripcom /etc/sysctl.conf)
                     54:        while [[ $# > 0 ]] ; do
                     55:                sysctl "$1"
1.267     millert    56:
1.520     bluhm      57:                case "$1" in
1.265     millert    58:                kern.maxproc=*)
1.520     bluhm      59:                        update_limit -p maxproc
                     60:                        ;;
1.265     millert    61:                kern.maxfiles=*)
1.520     bluhm      62:                        update_limit -n openfiles
                     63:                        ;;
1.265     millert    64:                esac
1.520     bluhm      65:                shift
1.265     millert    66:        done
                     67: }
                     68:
1.457     rpe        69: # Apply mixerctl.conf(5) settings.
1.452     rpe        70: mixerctl_conf() {
1.457     rpe        71:        stripcom /etc/mixerctl.conf |
                     72:        while read _line; do
                     73:                mixerctl -q "$_line" 2>/dev/null
1.265     millert    74:        done
                     75: }
                     76:
1.457     rpe        77: # Apply wsconsctl.conf(5) settings.
1.452     rpe        78: wsconsctl_conf() {
1.457     rpe        79:        [[ -x /sbin/wsconsctl ]] || return
1.267     millert    80:
1.457     rpe        81:        stripcom /etc/wsconsctl.conf |
                     82:        while read _line; do
1.458     rpe        83:                eval "wsconsctl $_line"
1.267     millert    84:        done
                     85: }
                     86:
1.495     rpe        87: # Push the old seed into the kernel, create a future seed  and create a seed
                     88: # file for the boot-loader.
1.452     rpe        89: random_seed() {
1.427     bluhm      90:        dd if=/var/db/host.random of=/dev/random bs=65536 count=1 status=none
                     91:        chmod 600 /var/db/host.random
                     92:        dd if=/dev/random of=/var/db/host.random bs=65536 count=1 status=none
                     93:        dd if=/dev/random of=/etc/random.seed bs=512 count=1 status=none
                     94:        chmod 600 /etc/random.seed
1.312     djm        95: }
                     96:
1.450     rpe        97: # Populate net.inet.(tcp|udp).baddynamic with the contents of /etc/services so
                     98: # as to avoid randomly allocating source ports that correspond to well-known
1.451     rpe        99: # services.
1.459     rpe       100: # Usage: fill_baddynamic tcp|udp
1.452     rpe       101: fill_baddynamic() {
1.390     halex     102:        local _service=$1
1.318     djm       103:        local _sysctl="net.inet.${_service}.baddynamic"
1.459     rpe       104:
1.390     halex     105:        stripcom /etc/services |
                    106:        {
1.459     rpe       107:                _ban=
1.390     halex     108:                while IFS="     /" read _name _port _srv _junk; do
1.459     rpe       109:                        [[ $_srv == $_service ]] || continue
                    110:
                    111:                        _ban="${_ban:+$_ban,}+$_port"
                    112:
1.390     halex     113:                        # Flush before argv gets too long
1.459     rpe       114:                        if ((${#_ban} > 1024)); then
                    115:                                sysctl -q "$_sysctl=$_ban"
                    116:                                _ban=
1.390     halex     117:                        fi
                    118:                done
1.459     rpe       119:                [[ -n $_ban ]] && sysctl -q "$_sysctl=$_ban"
1.390     halex     120:        }
1.318     djm       121: }
                    122:
1.450     rpe       123: # Start daemon using the rc.d daemon control scripts.
1.451     rpe       124: # Usage: start_daemon daemon1 daemon2 daemon3
1.452     rpe       125: start_daemon() {
1.460     rpe       126:        local _daemon
                    127:
                    128:        for _daemon; do
                    129:                eval "_do=\${${_daemon}_flags}"
                    130:                [[ $_do != NO ]] && /etc/rc.d/${_daemon} start
1.353     robert    131:        done
                    132: }
                    133:
1.469     tim       134: # Generate keys for isakmpd, iked and sshd if they don't exist yet.
1.452     rpe       135: make_keys() {
1.460     rpe       136:        local _isakmpd_key=/etc/isakmpd/private/local.key
                    137:        local _isakmpd_pub=/etc/isakmpd/local.pub
                    138:        local _iked_key=/etc/iked/private/local.key
                    139:        local _iked_pub=/etc/iked/local.pub
1.572     naddy     140:        local _ssh_pub=/etc/ssh/ssh_host_ed25519_key.pub _show_ssh_fp=false
1.460     rpe       141:
                    142:        if [[ ! -f $_isakmpd_key ]]; then
1.560     tobhe     143:                echo -n "openssl: generating isakmpd RSA keys... "
1.460     rpe       144:                if openssl genrsa -out $_isakmpd_key 2048 >/dev/null 2>&1 &&
                    145:                        chmod 600 $_isakmpd_key &&
                    146:                        openssl rsa -out $_isakmpd_pub -in $_isakmpd_key \
                    147:                            -pubout >/dev/null 2>&1; then
1.373     deraadt   148:                        echo done.
                    149:                else
                    150:                        echo failed.
                    151:                fi
                    152:        fi
                    153:
1.460     rpe       154:        if [[ ! -f $_iked_key ]]; then
1.560     tobhe     155:                echo -n "openssl: generating iked ECDSA keys... "
                    156:                if openssl ecparam -genkey -name prime256v1 -out $_iked_key >/dev/null 2>&1 &&
                    157:                        chmod 600 $_iked_key &&
                    158:                        openssl ec -out $_iked_pub -in $_iked_key \
                    159:                            -pubout >/dev/null 2>&1; then
                    160:                        echo done.
                    161:                else
                    162:                        echo failed.
                    163:                fi
1.373     deraadt   164:        fi
                    165:
1.572     naddy     166:        [[ -f $_ssh_pub ]] || _show_ssh_fp=true
1.373     deraadt   167:        ssh-keygen -A
1.572     naddy     168:        $_show_ssh_fp && ssh-keygen -lf $_ssh_pub |
                    169:            (read sz fp comm type && echo "sshd: $type $fp")
1.524     florian   170:
                    171:        if [[ ! -f /etc/soii.key ]]; then
1.525     rpe       172:                openssl rand -hex 16 > /etc/soii.key &&
1.524     florian   173:                    chmod 600 /etc/soii.key && sysctl -q \
                    174:                    "net.inet6.ip6.soiikey=$(</etc/soii.key)"
                    175:        fi
1.373     deraadt   176: }
                    177:
1.483     rpe       178: # Re-link libraries, placing the objects in a random order.
1.481     rpe       179: reorder_libs() {
1.521     rpe       180:        local _error=false _dkdev _liba _libas _mp _ro_list _tmpdir
1.522     rpe       181:        local _relink=/usr/share/relink
1.498     tb        182:
                    183:        [[ $library_aslr == NO ]] && return
                    184:
1.521     rpe       185:        # Skip if /usr/lib, /usr/libexec or /usr/share/relink are on nfs mounted
                    186:        # filesystems, otherwise record which ones are mounted read-only.
1.533     kn        187:        for _dkdev in $(df /usr/{lib,libexec} $_relink |
                    188:            sed '1d;s/ .*//' | sort -u); do
                    189:                _mp=$(mount -t ffs | grep "^$_dkdev") || return
                    190:                if [[ $_mp == *read-only* ]]; then
                    191:                        _ro_list="$_ro_list ${_mp%% *}"
1.521     rpe       192:                fi
                    193:        done
1.484     rpe       194:
1.569     deraadt   195:        echo 'reordering:'
1.523     tb        196:
1.556     jsg       197:        # Remount the (read-only) filesystems in _ro_list as read-write.
1.521     rpe       198:        for _mp in $_ro_list; do
                    199:                if ! mount -u -w $_mp; then
1.565     cheloha   200:                        echo '(failed).'
1.481     rpe       201:                        return
                    202:                fi
1.521     rpe       203:        done
1.509     tb        204:
                    205:        # Only choose the latest version of the libraries.
1.522     rpe       206:        for _liba in $_relink/usr/lib/lib{c,crypto}; do
1.513     zhuk      207:                _libas="$_libas $(ls $_liba.so.+([0-9.]).a | sort -rV | head -1)"
1.509     tb        208:        done
1.481     rpe       209:
1.522     rpe       210:        for _liba in $_relink/usr/libexec/ld.so.a $_libas; do
                    211:                _tmpdir=$(mktemp -dq $_relink/_rebuild.XXXXXXXXXXXX) &&
1.517     rpe       212:                (
                    213:                set -o errexit
1.534     kn        214:                _install='install -F -o root -g bin -m 0444'
1.517     rpe       215:                _lib=${_liba##*/}
                    216:                _lib=${_lib%.a}
1.522     rpe       217:                _lib_dir=${_liba#$_relink}
1.523     tb        218:                _lib_dir=${_lib_dir%/*}
1.517     rpe       219:                cd $_tmpdir
                    220:                ar x $_liba
                    221:                if [[ $_lib == ld.so ]]; then
1.566     florian   222:                        echo " $_lib"
1.537     guenther  223:                        args="-g -x -e _dl_start \
1.517     rpe       224:                            --version-script=Symbols.map --shared -Bsymbolic \
1.537     guenther  225:                            --no-undefined"
                    226:                        [[ -f ld.script ]] && args="$args -T ld.script"
                    227:                        ld $args -o ld.so.test $(ls *.o | sort -R)
1.517     rpe       228:                        chmod u+x test-ld.so
                    229:                        [[ $(./test-ld.so ok) == './test-ld.so: ok!' ]]
                    230:                        $_install /usr/libexec/ld.so /usr/libexec/ld.so.save
1.521     rpe       231:                        $_install ld.so.test $_lib_dir/ld.so
1.517     rpe       232:                else
1.566     florian   233:                        echo " ${_lib%%.*}"
1.541     naddy     234:                        cc -shared -o $_lib $(ls *.so | sort -R) $(<.ldadd)
1.475     deraadt   235:                        [[ -s $_lib ]] && file $_lib | fgrep -q 'shared object'
                    236:                        LD_BIND_NOW=1 LD_LIBRARY_PATH=$_tmpdir awk 'BEGIN {exit 0}'
1.500     deraadt   237:                        LD_BIND_NOW=1 LD_LIBRARY_PATH=$_tmpdir openssl \
                    238:                            x509 -in /etc/ssl/cert.pem -out /dev/null
1.521     rpe       239:                        $_install $_lib $_lib_dir/$_lib
1.517     rpe       240:                fi
1.485     rpe       241:                ) || { _error=true; break; }
1.475     deraadt   242:        done
1.481     rpe       243:
1.575   ! deraadt   244:        for _bin in $_relink/usr/sbin/sshd $_relink/usr/libexec/sshd-session \
        !           245:            $_relink/usr/bin/ssh-agent ; do
1.569     deraadt   246:                _tmpdir=$(mktemp -dq $_relink/_rebuild.XXXXXXXXXXXX) &&
                    247:                (
                    248:                set -o errexit
                    249:                cd $_tmpdir
                    250:                _binn=${_bin##*/}
                    251:                _bint=${_bin}/${_binn}.tar
                    252:                if [[ -f $_bint ]]; then
                    253:                        echo " $_binn"
                    254:                        tar xf $_bint
1.573     deraadt   255:                        if [[ -f install.sh ]]; then
                    256:                                sh install.sh >/dev/null 2>&1
                    257:                        else
                    258:                                make -f Makefile.relink relink >/dev/null 2>&1
                    259:                        fi
1.569     deraadt   260:                fi
                    261:                ) || { _error=true; break; }
                    262:        done
1.570     asou      263:
1.522     rpe       264:        rm -rf $_relink/_rebuild.*
1.485     rpe       265:
1.481     rpe       266:        # Restore previous mount state if it was changed.
1.521     rpe       267:        for _mp in $_ro_list; do
                    268:                mount -u -r $_mp || _error=true
                    269:        done
1.482     deraadt   270:
1.485     rpe       271:        if $_error; then
1.565     cheloha   272:                echo '(failed).'
1.485     rpe       273:        else
1.565     cheloha   274:                echo '.'
1.485     rpe       275:        fi
1.475     deraadt   276: }
                    277:
1.566     florian   278: # Read output of reorder_libs co-process and output on console.
                    279: wait_reorder_libs() {
                    280:        local _line
1.568     kn        281:
                    282:        [[ $library_aslr == NO ]] && return
1.567     kn        283:
1.566     florian   284:        while IFS= read -p _line; do
                    285:                echo -n "$_line"
                    286:        done
                    287:        echo
                    288: }
                    289:
1.483     rpe       290: # Run rc.* script and email output to root.
                    291: # Usage: run_upgrade_script firsttime|sysmerge
1.477     ajacouto  292: run_upgrade_script() {
                    293:        local _suffix=$1
1.491     rpe       294:
1.477     ajacouto  295:        [[ -n $_suffix ]] || return 1
1.491     rpe       296:
1.477     ajacouto  297:        if [[ -f /etc/rc.$_suffix ]]; then
1.516     ajacouto  298:                echo "running rc.$_suffix"
1.477     ajacouto  299:                mv /etc/rc.$_suffix /etc/rc.$_suffix.run
                    300:                . /etc/rc.$_suffix.run 2>&1 | tee /dev/tty |
                    301:                        mail -Es "$(hostname) rc.$_suffix output" root >/dev/null
                    302:        fi
                    303:        rm -f /etc/rc.$_suffix.run
                    304: }
                    305:
1.462     rpe       306: # Check filesystems, optionally by using a fsck(8) flag.
                    307: # Usage: do_fsck [-flag]
1.452     rpe       308: do_fsck() {
1.462     rpe       309:        fsck -p "$@"
1.429     claudio   310:        case $? in
1.462     rpe       311:        0)      ;;
                    312:        2)      exit 1
1.429     claudio   313:                ;;
1.462     rpe       314:        4)      echo "Rebooting..."
1.429     claudio   315:                reboot
                    316:                echo "Reboot failed; help!"
                    317:                exit 1
                    318:                ;;
1.462     rpe       319:        8)      echo "Automatic file system check failed; help!"
1.429     claudio   320:                exit 1
                    321:                ;;
1.462     rpe       322:        12)     echo "Boot interrupted."
1.429     claudio   323:                exit 1
                    324:                ;;
1.462     rpe       325:        130)    # Interrupt before catcher installed.
1.429     claudio   326:                exit 1
                    327:                ;;
1.462     rpe       328:        *)      echo "Unknown error; help!"
1.429     claudio   329:                exit 1
                    330:                ;;
                    331:        esac
                    332: }
                    333:
1.450     rpe       334: # End subroutines.
1.131     millert   335:
1.1       deraadt   336: stty status '^T'
                    337:
1.450     rpe       338: # Set shell to ignore SIGINT (2), but not children; shell catches SIGQUIT (3)
                    339: # and returns to single user after fsck.
1.1       deraadt   340: trap : 2
1.450     rpe       341: trap : 3       # Shouldn't be needed.
1.1       deraadt   342:
1.463     rpe       343: export HOME=/
                    344: export INRC=1
                    345: export PATH=/sbin:/bin:/usr/sbin:/usr/bin
1.544     deraadt   346:
                    347: # /etc/myname contains my symbolic name.
                    348: if [[ -f /etc/myname ]]; then
                    349:        hostname "$(stripcom /etc/myname)"
                    350: fi
1.395     deraadt   351:
1.450     rpe       352: # Must set the domainname before rc.conf, so YP startup choices can be made.
1.563     miod      353: if [[ -s /etc/defaultdomain && -z "$(sysctl -n kern.domainname)" ]]; then
1.463     rpe       354:        domainname "$(stripcom /etc/defaultdomain)"
1.395     deraadt   355: fi
1.108     deraadt   356:
1.495     rpe       357: # Get local functions from rc.subr to load rc.conf into scope.
1.428     robert    358: FUNCS_ONLY=1 . /etc/rc.d/rc.subr
                    359: _rc_parse_conf
1.343     robert    360:
1.495     rpe       361: # If executed with the 'shutdown' parameter by the halt, reboot or shutdown:
                    362: # - update seed files
                    363: # - execute the rc.d scripts specified by $pkg_scripts in reverse order
                    364: # - bring carp interfaces down gracefully
1.463     rpe       365: if [[ $1 == shutdown ]]; then
1.525     rpe       366:        if echo 2>/dev/null >>/var/db/host.random ||
1.437     bluhm     367:            echo 2>/dev/null >>/etc/random.seed; then
                    368:                random_seed
                    369:        else
                    370:                echo warning: cannot write random seed to disk
                    371:        fi
1.416     rpe       372:
1.469     tim       373:        # If we are in secure level 0, assume single user mode.
1.463     rpe       374:        if (($(sysctl -n kern.securelevel) == 0)); then
                    375:                echo 'single user: not running shutdown scripts'
                    376:        else
1.514     rpe       377:                set -A _d -- $pkg_scripts
                    378:                _i=${#_d[*]}
                    379:                if ((_i)); then
1.413     deraadt   380:                        echo -n 'stopping package daemons:'
1.514     rpe       381:                        while ((--_i >= 0)); do
                    382:                                [[ -x /etc/rc.d/${_d[_i]} ]] &&
                    383:                                        /etc/rc.d/${_d[_i]} stop
1.413     deraadt   384:                        done
1.527     sthen     385:                        echo '.'
                    386:                fi
                    387:
                    388:                if /etc/rc.d/vmd check > /dev/null; then
                    389:                        echo -n 'stopping VMs'
                    390:                        /etc/rc.d/vmd stop > /dev/null
1.413     deraadt   391:                        echo '.'
                    392:                fi
                    393:
1.463     rpe       394:                [[ -f /etc/rc.shutdown ]] && sh /etc/rc.shutdown
1.413     deraadt   395:        fi
1.240     mcbride   396:
1.463     rpe       397:        ifconfig | while read _if _junk; do
1.474     rpe       398:                [[ $_if == carp+([0-9]): ]] && ifconfig ${_if%:} down
1.413     deraadt   399:        done
1.246     mcbride   400:
1.108     deraadt   401:        exit 0
1.1       deraadt   402: fi
1.98      jakob     403:
1.540     deraadt   404: # If bootblocks failed to give us random, try to cause some churn
                    405: (dmesg; sysctl hw.{uuid,serialno,sensors} ) >/dev/random 2>&1
                    406:
1.482     deraadt   407: # Add swap block-devices.
1.172     miod      408: swapctl -A -t blk
1.170     deraadt   409:
1.495     rpe       410: # Run filesystem check unless a /fastboot file exists.
1.463     rpe       411: if [[ -e /fastboot ]]; then
1.1       deraadt   412:        echo "Fast boot: skipping disk checks."
1.463     rpe       413: elif [[ $1 == autoboot ]]; then
1.1       deraadt   414:        echo "Automatic boot in progress: starting file system checks."
1.429     claudio   415:        do_fsck
1.1       deraadt   416: fi
                    417:
1.495     rpe       418: # From now on, allow user to interrupt (^C) the boot process.
1.1       deraadt   419: trap "echo 'Boot interrupted.'; exit 1" 3
                    420:
1.495     rpe       421: # Unmount all filesystems except root.
1.1       deraadt   422: umount -a >/dev/null 2>&1
1.495     rpe       423:
                    424: # Mount all filesystems except those of type NFS and VND.
1.303     grunk     425: mount -a -t nonfs,vnd
1.177     deraadt   426:
1.495     rpe       427: # Re-mount the root filesystem read/writeable. (root on nfs requires this,
                    428: # others aren't hurt.)
                    429: mount -uw /
1.499     deraadt   430: chmod og-rwx /bsd
1.503     deraadt   431: ln -fh /bsd /bsd.booted
1.495     rpe       432:
                    433: rm -f /fastboot
                    434:
1.505     tedu      435: # Set flags on ttys.
1.1       deraadt   436: ttyflags -a
1.77      angelos   437:
1.464     rpe       438: # Set keyboard encoding.
                    439: if [[ -x /sbin/kbd && -s /etc/kbdtype ]]; then
1.541     naddy     440:        kbd "$(</etc/kbdtype)"
1.252     mcbride   441: fi
                    442:
1.279     deraadt   443: wsconsctl_conf
                    444:
1.464     rpe       445: # Set initial temporary pf rule set.
                    446: if [[ $pf != NO ]]; then
1.511     rpe       447:        RULES="
1.510     rpe       448:        block all
                    449:        pass on lo0
                    450:        pass in proto tcp from any to any port ssh keep state
                    451:        pass out proto { tcp, udp } from any to any port domain keep state
                    452:        pass out inet proto icmp all icmp-type echoreq keep state
                    453:        pass out inet proto udp from any port bootpc to any port bootps
1.511     rpe       454:        pass in inet proto udp from any port bootps to any port bootpc"
1.510     rpe       455:
1.257     grange    456:        if ifconfig lo0 inet6 >/dev/null 2>&1; then
1.510     rpe       457:                RULES="$RULES
                    458:                pass out inet6 proto icmp6 all icmp6-type neighbrsol
1.571     phessler  459:                pass inet6 proto icmp6 all icmp6-type neighbradv no state
1.510     rpe       460:                pass out inet6 proto icmp6 all icmp6-type routersol
                    461:                pass in inet6 proto icmp6 all icmp6-type routeradv
                    462:                pass out inet6 proto udp from any port dhcpv6-client to any port dhcpv6-server
                    463:                pass in inet6 proto udp from any port dhcpv6-server to any port dhcpv6-client"
1.257     grange    464:        fi
1.510     rpe       465:
                    466:        RULES="$RULES
                    467:        pass in proto carp keep state (no-sync)
                    468:        pass out proto carp !received-on any keep state (no-sync)"
                    469:
1.545     naddy     470:        if (($(sysctl -n vfs.mounts.nfs 2>/dev/null)+0 > 0)); then
1.511     rpe       471:                # Don't kill NFS.
1.510     rpe       472:                RULES="set reassemble yes no-df
                    473:                $RULES
                    474:                pass in proto { tcp, udp } from any port { sunrpc, nfsd } to any
                    475:                pass out proto { tcp, udp } from any to any port { sunrpc, nfsd } !received-on any"
1.474     rpe       476:        fi
1.511     rpe       477:
1.464     rpe       478:        print -- "$RULES" | pfctl -f -
1.269     dhartmei  479:        pfctl -e
1.176     kjell     480: fi
1.318     djm       481:
                    482: fill_baddynamic udp
                    483: fill_baddynamic tcp
1.176     kjell     484:
1.267     millert   485: sysctl_conf
1.260     jsg       486:
1.557     florian   487: mount -s /var >/dev/null 2>&1          # cannot be on NFS
                    488: mount -s /var/log >/dev/null 2>&1      # cannot be on NFS
1.564     deraadt   489: mount -s /usr >/dev/null 2>&1          # if NFS, fstab must use IP address
1.557     florian   490:
1.566     florian   491: reorder_libs 2>&1 |&
                    492:
1.557     florian   493: start_daemon slaacd dhcpleased resolvd >/dev/null 2>&1
1.501     florian   494:
1.1       deraadt   495: echo 'starting network'
1.464     rpe       496:
                    497: # Set carp interlock by increasing the demotion counter.
                    498: # Prevents carp from preempting until the system is booted.
1.536     tedu      499: ifconfig -g carp carpdemote 128
1.464     rpe       500:
1.439     ajacouto  501: sh /etc/netstart
1.542     deraadt   502:
1.557     florian   503: start_daemon unwind >/dev/null 2>&1
1.542     deraadt   504:
1.550     deraadt   505: random_seed
                    506:
1.566     florian   507: wait_reorder_libs
1.550     deraadt   508:
1.450     rpe       509: # Load pf rules and bring up pfsync interface.
1.464     rpe       510: if [[ $pf != NO ]]; then
                    511:        if [[ -f /etc/pf.conf ]]; then
1.449     ajacouto  512:                pfctl -f /etc/pf.conf
1.309     mpf       513:        fi
1.464     rpe       514:        if [[ -f /etc/hostname.pfsync0 ]]; then
1.435     deraadt   515:                sh /etc/netstart pfsync0
1.367     deraadt   516:        fi
1.176     kjell     517: fi
1.29      deraadt   518:
1.450     rpe       519: # Clean up left-over files.
1.492     jca       520: rm -f /etc/nologin /var/spool/lock/LCK.*
1.247     henning   521: (cd /var/run && { rm -rf -- *; install -c -m 664 -g utmp /dev/null utmp; })
1.196     beck      522: (cd /var/authpf && rm -rf -- *)
1.96      alex      523:
1.495     rpe       524: # Save a copy of the boot messages.
                    525: dmesg >/var/run/dmesg.boot
1.55      deraadt   526:
1.373     deraadt   527: make_keys
                    528:
1.379     deraadt   529: echo -n 'starting early daemons:'
1.543     tedu      530: start_daemon syslogd ldattach pflogd nsd unbound ntpd
1.429     claudio   531: start_daemon iscsid isakmpd iked sasyncd ldapd npppd
1.353     robert    532: echo '.'
1.280     hshoexer  533:
1.450     rpe       534: # Load IPsec rules.
1.464     rpe       535: if [[ $ipsec != NO && -f /etc/ipsec.conf ]]; then
                    536:        ipsecctl -f /etc/ipsec.conf
1.40      provos    537: fi
1.1       deraadt   538:
1.379     deraadt   539: echo -n 'starting RPC daemons:'
1.562     deraadt   540: start_daemon portmap
1.464     rpe       541: if [[ -n $(domainname) ]]; then
1.562     deraadt   542:        start_daemon ypldap ypserv ypbind
1.376     deraadt   543: fi
1.399     dlg       544: start_daemon mountd nfsd lockd statd amd
1.1       deraadt   545: echo '.'
1.58      deraadt   546:
1.464     rpe       547: # Check and mount remaining file systems and enable additional swap.
1.278     otto      548: mount -a
1.172     miod      549: swapctl -A -t noblk
1.429     claudio   550: do_fsck -N
                    551: mount -a -N
1.1       deraadt   552:
1.549     deraadt   553: # Build kvm(3) and /dev databases.
                    554: kvm_mkdb
                    555: dev_mkdb
                    556:
1.450     rpe       557: # /var/crash should be a directory or a symbolic link to the crash directory
                    558: # if core dumps are to be saved.
1.464     rpe       559: if [[ -d /var/crash ]]; then
                    560:        savecore $savecore_flags /var/crash
1.487     rpe       561: fi
                    562:
                    563: # Store ACPI tables in /var/db/acpi to be used by sendbug(1).
                    564: if [[ -x /usr/sbin/acpidump ]]; then
1.530     kettenis  565:        acpidump -q -o /var/db/acpi/
1.90      art       566: fi
                    567:
1.464     rpe       568: if [[ $check_quotas == YES ]]; then
1.41      downsj    569:        echo -n 'checking quotas:'
                    570:        quotacheck -a
                    571:        echo ' done.'
                    572:        quotaon -a
                    573: fi
1.464     rpe       574:
                    575: # Set proper permission for the tty device files.
1.101     deraadt   576: chmod 666 /dev/tty[pqrstuvwxyzPQRST]*
1.226     millert   577: chown root:wheel /dev/tty[pqrstuvwxyzPQRST]*
1.1       deraadt   578:
1.495     rpe       579: # Check for the password temp/lock file.
1.467     rpe       580: if [[ -f /etc/ptmp ]]; then
1.1       deraadt   581:        logger -s -p auth.err \
1.376     deraadt   582:            'password file may be incorrect -- /etc/ptmp exists'
1.32      deraadt   583: fi
                    584:
1.49      millert   585: echo clearing /tmp
                    586:
1.450     rpe       587: # Prune quickly with one rm, then use find to clean up /tmp/[lqv]*
                    588: # (not needed with mfs /tmp, but doesn't hurt there...).
1.444     deraadt   589: (cd /tmp && rm -rf [a-km-pr-uw-zA-Z]*)
1.339     sthen     590: (cd /tmp &&
1.443     millert   591:     find . -maxdepth 1 ! -name . ! -name lost+found ! -name quota.user \
1.444     deraadt   592:        ! -name quota.group ! -name vi.recover -execdir rm -rf -- {} \;)
1.373     deraadt   593:
1.462     rpe       594: # Create Unix sockets directories for X if needed and make sure they have
                    595: # correct permissions.
                    596: [[ -d /usr/X11R6/lib ]] && mkdir -m 1777 /tmp/.{X11,ICE}-unix
1.203     hugh      597:
1.467     rpe       598: [[ -f /etc/rc.securelevel ]] && sh /etc/rc.securelevel
                    599:
1.450     rpe       600: # rc.securelevel did not specifically set -1 or 2, so select the default: 1.
1.467     rpe       601: (($(sysctl -n kern.securelevel) == 0)) && sysctl kern.securelevel=1
                    602:
1.1       deraadt   603:
1.450     rpe       604: # Patch /etc/motd.
1.467     rpe       605: if [[ ! -f /etc/motd ]]; then
1.34      deraadt   606:        install -c -o root -g wheel -m 664 /dev/null /etc/motd
                    607: fi
1.467     rpe       608: if T=$(mktemp /tmp/_motd.XXXXXXXXXX); then
1.451     rpe       609:        sysctl -n kern.version | sed 1q >$T
1.494     schwarze  610:        sed -n '/^$/,$p' </etc/motd >>$T
1.102     millert   611:        cmp -s $T /etc/motd || cp $T /etc/motd
                    612:        rm -f $T
                    613: fi
1.34      deraadt   614:
1.467     rpe       615: if [[ $accounting == YES ]]; then
                    616:        [[ ! -f /var/account/acct ]] && touch /var/account/acct
                    617:        echo 'turning on accounting'
                    618:        accton /var/account/acct
1.1       deraadt   619: fi
                    620:
1.467     rpe       621: if [[ -x /sbin/ldconfig ]]; then
1.115     deraadt   622:        echo 'creating runtime link editor directory cache.'
1.471     rpe       623:        [[ -d /usr/local/lib ]] && shlib_dirs="/usr/local/lib $shlib_dirs"
1.467     rpe       624:        [[ -d /usr/X11R6/lib ]] && shlib_dirs="/usr/X11R6/lib $shlib_dirs"
1.115     deraadt   625:        ldconfig $shlib_dirs
1.231     millert   626: fi
                    627:
1.451     rpe       628: echo 'preserving editor files.'; /usr/libexec/vi.recover
1.244     markus    629:
1.477     ajacouto  630: # If rc.sysmerge exists, run it just once, and make sure it is deleted.
                    631: run_upgrade_script sysmerge
                    632:
1.353     robert    633: echo -n 'starting network daemons:'
1.555     claudio   634: start_daemon ldomd sshd snmpd ldpd ripd ospfd ospf6d bgpd ifstated
1.529     florian   635: start_daemon relayd dhcpd dhcrelay mrouted dvmrpd radiusd eigrpd route6d
1.559     claudio   636: start_daemon rad hostapd lpd smtpd slowcgi bgplgd httpd ftpd
1.461     sthen     637: start_daemon ftpproxy ftpproxy6 tftpd tftpproxy identd inetd rarpd bootparamd
1.488     reyk      638: start_daemon rbootd mopd vmd spamd spamlogd sndiod
1.377     robert    639: echo '.'
1.335     deraadt   640:
1.450     rpe       641: # If rc.firsttime exists, run it just once, and make sure it is deleted.
1.477     ajacouto  642: run_upgrade_script firsttime
1.352     ajacouto  643:
1.450     rpe       644: # Run rc.d(8) scripts from packages.
1.467     rpe       645: if [[ -n $pkg_scripts ]]; then
1.352     ajacouto  646:        echo -n 'starting package daemons:'
1.467     rpe       647:        for _daemon in $pkg_scripts; do
                    648:                if [[ -x /etc/rc.d/$_daemon ]]; then
                    649:                        start_daemon $_daemon
1.410     espie     650:                else
1.467     rpe       651:                        echo -n " ${_daemon}(absent)"
1.410     espie     652:                fi
1.352     ajacouto  653:        done
                    654:        echo '.'
                    655: fi
1.17      deraadt   656:
1.467     rpe       657: [[ -f /etc/rc.local ]] && sh /etc/rc.local
1.73      millert   658:
1.495     rpe       659: # Disable carp interlock.
1.536     tedu      660: ifconfig -g carp -carpdemote 128
1.286     mcbride   661:
1.379     deraadt   662: mixerctl_conf
1.467     rpe       663:
1.379     deraadt   664: echo -n 'starting local daemons:'
1.493     matthieu  665: start_daemon apmd sensorsd hotplugd watchdogd cron wsmoused xenodm
1.73      millert   666: echo '.'
1.502     rpe       667:
1.515     rpe       668: # Re-link the kernel, placing the objects in a random order.
                    669: # Replace current with relinked kernel and inform root about it.
                    670: /usr/libexec/reorder_kernel &
1.1       deraadt   671:
                    672: date
                    673: exit 0